#ifndef OPTION_ASDL_H
#define OPTION_ASDL_H

namespace option_asdl {
namespace option_i {
  const int errexit = 1;
  const int nounset = 2;
  const int pipefail = 3;
  const int inherit_errexit = 4;
  const int nullglob = 5;
  const int verbose_errexit = 6;
  const int noexec = 7;
  const int xtrace = 8;
  const int verbose = 9;
  const int noglob = 10;
  const int noclobber = 11;
  const int posix = 12;
  const int vi = 13;
  const int emacs = 14;
  const int interactive = 15;
  const int hashall = 16;
  const int failglob = 17;
  const int extglob = 18;
  const int eval_unsafe_arith = 19;
  const int parse_dynamic_arith = 20;
  const int compat_array = 21;
  const int allow_csub_psub = 22;
  const int dynamic_scope = 23;
  const int redefine_module = 24;
  const int _running_trap = 25;
  const int _running_hay = 26;
  const int strict_argv = 27;
  const int strict_arith = 28;
  const int strict_array = 29;
  const int strict_control_flow = 30;
  const int strict_errexit = 31;
  const int strict_nameref = 32;
  const int strict_word_eval = 33;
  const int strict_tilde = 34;
  const int strict_glob = 35;
  const int parse_at = 36;
  const int parse_proc = 37;
  const int parse_brace = 38;
  const int parse_equals = 39;
  const int parse_paren = 40;
  const int parse_raw_string = 41;
  const int parse_triple_quote = 42;
  const int simple_word_eval = 43;
  const int dashglob = 44;
  const int expand_aliases = 45;
  const int command_sub_errexit = 46;
  const int process_sub_fail = 47;
  const int xtrace_rich = 48;
  const int xtrace_details = 49;
  const int sigpipe_status_ok = 50;
  const int redefine_proc = 51;
  const int parse_at_all = 52;
  const int parse_backslash = 53;
  const int parse_backticks = 54;
  const int parse_dollar = 55;
  const int parse_ignored = 56;
  const int parse_sh_assign = 57;
  const int parse_dparen = 58;
  const int parse_bare_word = 59;
  const int parse_sloppy_case = 60;
  const int simple_echo = 61;
  const int simple_eval_builtin = 62;
  const int simple_test_builtin = 63;
  const int parse_tea = 64;
  const int lastpipe = 65;
  const int progcomp = 66;
  const int histappend = 67;
  const int hostcomplete = 68;
  const int cmdhist = 69;
  const int assoc_expand_once = 70;
  const int autocd = 71;
  const int cdable_vars = 72;
  const int cdspell = 73;
  const int checkhash = 74;
  const int checkjobs = 75;
  const int checkwinsize = 76;
  const int complete_fullquote = 77;
  const int direxpand = 78;
  const int dirspell = 79;
  const int dotglob = 80;
  const int execfail = 81;
  const int extdebug = 82;
  const int extquote = 83;
  const int force_fignore = 84;
  const int globasciiranges = 85;
  const int globstar = 86;
  const int gnu_errfmt = 87;
  const int histreedit = 88;
  const int histverify = 89;
  const int huponexit = 90;
  const int interactive_comments = 91;
  const int lithist = 92;
  const int localvar_inherit = 93;
  const int localvar_unset = 94;
  const int login_shell = 95;
  const int mailwarn = 96;
  const int no_empty_cmd_completion = 97;
  const int nocaseglob = 98;
  const int nocasematch = 99;
  const int progcomp_alias = 100;
  const int promptvars = 101;
  const int restricted_shell = 102;
  const int shift_verbose = 103;
  const int sourcepath = 104;
  const int xpg_echo = 105;
  const int ARRAY_SIZE = 106;
};

typedef int option_t;

namespace builtin_i {
  const int colon = 1;
  const int dot = 2;
  const int exec_ = 3;
  const int eval = 4;
  const int set = 5;
  const int shift = 6;
  const int times = 7;
  const int trap = 8;
  const int unset = 9;
  const int builtin = 10;
  const int readonly = 11;
  const int local = 12;
  const int declare = 13;
  const int typeset = 14;
  const int export_ = 15;
  const int test = 16;
  const int bracket = 17;
  const int true_ = 18;
  const int false_ = 19;
  const int try_ = 20;
  const int read = 21;
  const int echo = 22;
  const int printf = 23;
  const int mapfile = 24;
  const int readarray = 25;
  const int cd = 26;
  const int pushd = 27;
  const int popd = 28;
  const int dirs = 29;
  const int pwd = 30;
  const int source = 31;
  const int umask = 32;
  const int wait = 33;
  const int jobs = 34;
  const int fg = 35;
  const int bg = 36;
  const int shopt = 37;
  const int complete = 38;
  const int compgen = 39;
  const int compopt = 40;
  const int compadjust = 41;
  const int getopts = 42;
  const int command = 43;
  const int type = 44;
  const int hash = 45;
  const int help = 46;
  const int history = 47;
  const int alias = 48;
  const int unalias = 49;
  const int bind = 50;
  const int append = 51;
  const int write = 52;
  const int json = 53;
  const int pp = 54;
  const int hay = 55;
  const int haynode = 56;
  const int module = 57;
  const int use = 58;
  const int fork = 59;
  const int forkwait = 60;
  const int fopen = 61;
  const int shvar = 62;
  const int runproc = 63;
  const int boolstatus = 64;
  const int argparse = 65;
  const int describe = 66;
  const int push_registers = 67;
  const int cat = 68;
  const int ARRAY_SIZE = 69;
};

typedef int builtin_t;


}  // namespace option_asdl

#endif  // OPTION_ASDL_H
